#ifndef VolumeMESHPROCESSING_H
#define VolumeMESHPROCESSING_H

#include <QMainWindow>
#include "CenterMainViewerWidget.h"

class VolumeMeshProcessing : public QMainWindow
{
	Q_OBJECT

public:
	VolumeMeshProcessing();
	~VolumeMeshProcessing();

private:
	void initMainWindow();
	void createCenterWidget();
	void createAction();
	void CreateMenu();
	void createContextMenu();
	void createToolBar();
	void createStatusBar();

private slots:
	void setMouseMode_slot(int mm);
	void setDrawMode_slot(int dm);
	//viewer
	void wireFrameShow();
	void solidflatShow();
	void flatLinesShow();
	void allLinesShow();
	void allPointsShow();
	void allPolysShow();
	void singularityShow();
	void textureShow();
	//pick
	void pickCellMode();
	void pickVolumeMode();
	void pickSheetMode();
	void pickVertexMode();
	void pickPointMode();
	void pickFaceMode();
	void pickEdgeMode();
	void moveVertexMode();

	//save
	void saveScreen();
	//subdivide
	void subdivideTetra();
	void transform_mesh();
	void create_grid_all_hex_mesh();
	void create_grid_mesh();
private:
	// File Actions.
	QAction* openAction;
	QAction* saveAction;
	QAction* exitAction;
	QAction* clearAction;
	//save Action
	QAction* saveScreenAction;

	// View Actions.
	QAction* wireFrameAction;
	QAction* solidflatAction;
	QAction* flatLinesAction;
	QAction* allLinesAction;
	QAction* allPointsAction;
	QAction* allPolyAction;
	QAction* SingularityAction;
	QAction* textureAction;

	//Pick Actions
	QAction* pickCellAction;
	QAction* pickVolumeAction;
	QAction* pickSheetAction;
	QAction* pickVertexAction;
	QAction* pickPointAction;
	QAction* pickFaceAction;
	QAction* pickEdgeAction;
	QAction* moveVertexAction;

	//subdivide
	QAction* subdivideTetraAction;
	QAction* transform_mesh_Action;
	QAction* create_grid_all_hex_mesh_Action;
	QAction* create_grid_mesh_Action;

	// Menus.
	QMenu* fileMenu;
	QMenu* viewMenu;
	QMenu* pickMenu;
	QMenu* AuxMenu;

	// ToolBars.
	QToolBar* fileToolBar;
	QToolBar* viewToolBar;
	QToolBar* pickToolBar;
	QToolBar* saveToolBar;

	//label
	QLabel* statusLabel;

private:
	centerWidget* center;
	int latestDrawMode;

private:
	void setAllActionChecked(bool b);
	void setAllMouseActionChecked(bool b);
	void setAllViewActionChecked(bool b);

protected:
	//void dragEnterEvent(QDragEnterEvent* event);
	//void dropEvent(QDropEvent* event);
};

#endif // VolumeMESHPROCESSING_H
