#include "VolumeMeshParameterDialog.h"

parameterDialog::parameterDialog(QWidget* parent)
	:QDialog(parent)
{
	initDialog();
}

parameterDialog::~parameterDialog(){}

void parameterDialog::initDialog()
{
	createWidget();
	createLayout();
}

void parameterDialog::createWidget()
{
	createSVMWidget();
}

void parameterDialog::createLayout()
{
	tabWidget = new QTabWidget();
	tabWidget->addTab(viewVM,"SVM");

	QHBoxLayout *layout = new QHBoxLayout();
	layout->addWidget(tabWidget);

	setLayout(layout);
}

void parameterDialog::keyPressEvent(QKeyEvent* _event)
{
	switch(_event->key())
	{
	//case Qt::Key_C://change between insert mode and trans mode
	//	change_insert_mode();
	//	break;
	case Qt::Key_Q:
	case Qt::Key_Escape:
		qApp->quit();
	}
	_event->ignore();
}

void parameterDialog::createSVMWidget()
{
	draw_main_scene = new QCheckBox("Draw Main Scene");
	draw_main_scene->setCheckable(true); draw_main_scene->setChecked(true);
	//construct the show Volume mesh dialog
	leftRightShow = new QCheckBox("Show Right Part");
	leftRightShow->setCheckState(Qt::Checked);
	upDownShow = new QCheckBox("Show Down Part");
	upDownShow->setCheckState(Qt::Checked);
	backFrontShow = new QCheckBox("Show Back Part");
	backFrontShow->setCheckState(Qt::Checked);

	xSlider = new QLabel("X : ");
	XSlider = new QSlider(Qt::Horizontal);
	XSlider->setMinimum(0);
	XSlider->setMaximum(100);
	XSlider->setValue(0);
	xSlider->setBuddy(XSlider);

	ySlider = new QLabel("Y : ");
	YSlider = new QSlider(Qt::Horizontal);
	YSlider->setMinimum(0);
	YSlider->setMaximum(100);
	YSlider->setValue(0);
	ySlider->setBuddy(YSlider);

	zSlider = new QLabel("Z : ");
	ZSlider = new QSlider(Qt::Horizontal);
	ZSlider->setMinimum(0);
	ZSlider->setMaximum(100);
	ZSlider->setValue(0);
	zSlider->setBuddy(ZSlider);

	draw_inv_tet = new QCheckBox("Draw Flipped Tet");
	draw_inv_tet->setCheckable(true); draw_inv_tet->setChecked(false);

	save_show_mesh = new QPushButton("Save Show Mesh");
	save_mesh_graph = new QPushButton("Save Mesh Graph");
	save_hex_mesh_graph = new QPushButton("Save Hex Mesh Graph");
	construct_vertex_texture = new QPushButton("Generate Vertex Texture");

	int svm_index = 0;
	QGridLayout* layout1 = new QGridLayout();
	layout1->addWidget(draw_main_scene, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(leftRightShow, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(upDownShow, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(backFrontShow, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(xSlider, svm_index, 0, 1, 1);
	layout1->addWidget(XSlider, svm_index, 1, 1, 1); ++svm_index;
	layout1->addWidget(ySlider, svm_index, 0, 1, 1);
	layout1->addWidget(YSlider, svm_index, 1, 1, 1); ++svm_index;
	layout1->addWidget(zSlider, svm_index, 0, 1, 1);
	layout1->addWidget(ZSlider, svm_index, 1, 1, 1); ++svm_index;
	layout1->addWidget(draw_inv_tet, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(save_show_mesh, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(save_mesh_graph, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(save_hex_mesh_graph, svm_index, 0, 1, 2); ++svm_index;
	layout1->addWidget(construct_vertex_texture, svm_index, 0, 1, 2); ++svm_index;

	basic_draw_Box = new QGroupBox("Basic Drawing");
	basic_draw_Box->setLayout(layout1);
	leftLabel = new QLabel("Blank");

	/*choose_point_surface = new QRadioButton("choose point on surface");
	choose_point_surface->setChecked(true);
	choose_point_other = new QRadioButton("choose point on other");
	choose_point_other->setChecked(false);
	choose_point_group = new QButtonGroup();
	choose_point_group->addButton(choose_point_surface, MeshField::POINT_ON_SURFACE);
	choose_point_group->addButton(choose_point_other, MeshField::POINT_ON_OTHER);
	extend_start = new QLabel("Extend Start");
	start_Slider = new QSlider(Qt::Horizontal);
	start_Slider->setMinimum(0);
	start_Slider->setMaximum(100);
	start_Slider->setValue(0);
	extend_start->setBuddy(start_Slider);

	extend_end = new QLabel("Extend End");
	end_Slider = new QSlider(Qt::Horizontal);
	end_Slider->setMinimum(0);
	end_Slider->setMaximum(100);
	end_Slider->setValue(100);
	extend_end->setBuddy(end_Slider);

	angle_phi = new QLabel("phi : ");
	phi_Slider = new QSlider(Qt::Horizontal);
	phi_Slider->setMinimum(0);
	phi_Slider->setMaximum(100);
	phi_Slider->setValue(0.0);
	angle_phi->setBuddy(phi_Slider);

	angle_alpha = new QLabel("alpha : ");
	alpha_Slider = new QSlider(Qt::Horizontal);
	alpha_Slider->setMinimum(0.0);
	alpha_Slider->setMaximum(100.0);
	alpha_Slider->setValue(0.0);
	angle_alpha->setBuddy(alpha_Slider);

	find_exist_end = new QPushButton("find exist end");
	draw_active_lines = new QCheckBox("draw active lines");
	draw_active_lines->setCheckable(true); draw_active_lines->setChecked(false);

	int i_l_index = 0;
	QGridLayout* insert_line_layout = new QGridLayout();
	insert_line_layout->addWidget(choose_point_surface, i_l_index, 0, 1,2); i_l_index += 1;
	insert_line_layout->addWidget(choose_point_other, i_l_index, 0, 1,2); i_l_index += 1;
	insert_line_layout->addWidget(extend_start, i_l_index, 0, 1,1);
	insert_line_layout->addWidget(start_Slider, i_l_index, 1, 1,1);i_l_index += 1;
	insert_line_layout->addWidget(extend_end, i_l_index, 0, 1,1);
	insert_line_layout->addWidget(end_Slider, i_l_index, 1, 1,1); i_l_index += 1;
	insert_line_layout->addWidget(angle_phi, i_l_index, 0, 1,1);
	insert_line_layout->addWidget(phi_Slider, i_l_index, 1, 1,1); i_l_index += 1;
	insert_line_layout->addWidget(angle_alpha, i_l_index, 0, 1,1);
	insert_line_layout->addWidget(alpha_Slider, i_l_index, 1, 1,1); i_l_index += 1;
	insert_line_layout->addWidget(find_exist_end, i_l_index, 0, 1, 2); i_l_index += 1;
	insert_line_layout->addWidget(draw_active_lines, i_l_index, 0, 1, 2); i_l_index += 1;

	insert_lines = new QGroupBox();
	insert_lines->setLayout(insert_line_layout);*/

	int main_index = 0;
	QGridLayout* main_layout = new QGridLayout();
	main_layout->addWidget(basic_draw_Box, main_index, 0, svm_index, 1); main_index += svm_index;
	//main_layout->addWidget(insert_lines,main_index, 0, i_l_index, 1); main_index += svm_index;
	main_layout->addWidget(leftLabel, main_index, 0, 15, 1);

	showVolumeMesh = new QWidget();
	showVolumeMesh->setLayout(main_layout);
	viewVM = new QScrollArea;
	viewVM->setFocusPolicy(Qt::NoFocus);
	viewVM->setFrameStyle(QFrame::NoFrame);
	viewVM->setWidget(showVolumeMesh);
	viewVM->setWidgetResizable(true);

	//some slots and signals
	connect(draw_main_scene, SIGNAL(stateChanged(int)), SIGNAL(draw_main_scene_signal(int)));

	connect(leftRightShow, SIGNAL(stateChanged(int)), SIGNAL(leftrightChanged(int)));
	connect(upDownShow, SIGNAL(stateChanged(int)), SIGNAL(updownChanged(int)));
	connect(backFrontShow, SIGNAL(stateChanged(int)), SIGNAL(backfrontChanged(int)));

	connect(XSlider, SIGNAL(valueChanged(int)), SIGNAL(xslidderChanged(int)));
	connect(YSlider, SIGNAL(valueChanged(int)), SIGNAL(yslidderChanged(int)));
	connect(ZSlider, SIGNAL(valueChanged(int)), SIGNAL(zslidderChanged(int)));

	connect(draw_inv_tet, SIGNAL(stateChanged(int)), SIGNAL(set_draw_inv_tet_signal(int)));
	connect(save_show_mesh, SIGNAL(clicked()), SIGNAL(save_show_mesh_signal()));
	connect(save_mesh_graph, SIGNAL(clicked()), SIGNAL(save_mesh_graph_signal()));
	connect(save_hex_mesh_graph, SIGNAL(clicked()), SIGNAL(save_mesh_graph_hex_signal()));
	connect(construct_vertex_texture, SIGNAL(clicked()), SIGNAL(construct_vertex_texture_signal()));


	/*connect(choose_point_surface, SIGNAL(clicked()), SIGNAL(choose_point_signal()));
	connect(choose_point_other, SIGNAL(clicked()), SIGNAL(choose_point_signal()));
	connect(start_Slider, SIGNAL(valueChanged(int)),SIGNAL(start_slider_changed(int)));
	connect(end_Slider, SIGNAL(valueChanged(int)),SIGNAL(end_slider_changed(int)));
	connect(phi_Slider, SIGNAL(valueChanged(int)),SIGNAL(phi_slider_changed(int)));
	connect(alpha_Slider, SIGNAL(valueChanged(int)),SIGNAL(alpha_slider_changed(int)));
	connect(find_exist_end, SIGNAL(clicked()), SIGNAL(find_exist_end_signal()));
	connect(draw_active_lines, SIGNAL(stateChanged(int)), SIGNAL(draw_active_lines_signal(int)));*/
}
