#ifndef PARAMETER_DIALOG_H 
#define PARAMETER_DIALOG_H

#include <QApplication>
#include <QtWidgets>

class parameterDialog : public QDialog
{
	Q_OBJECT
public:
	parameterDialog(QWidget* parent=0);
	~parameterDialog();

	QSize sizeHint()
	{
		QRect rect = QApplication::desktop()->screenGeometry();
		return QSize( int(rect.width()*0.1),rect.height() );
	}
protected:
	virtual void keyPressEvent(QKeyEvent*);

#pragma region Show Volume mesh
public:
	//get the collapse and extract direction
	int ColumnCollapseID();
	int ColumnCollapseDirID();
	int sheetExtractID();
	int ColumnSwapID();
	int ColumnSwapDirID();
	int ColumnSplitID();

	void setEnableForSMButton(bool state);
	void setEnableForPMIButton(bool state);
	void setEnableForSBOButton(bool state);
	void setEnableForDOButton(bool state);
	void setEnableForOVMButton(bool state);
	
	/*int get_choose_point()
	{
		return choose_point_group->checkedId();
	}*/
signals:
	void draw_main_scene_signal(int);
	void leftrightChanged(int state);
	void updownChanged(int state);
	void backfrontChanged(int state);

	void xslidderChanged(int value);
	void yslidderChanged(int value);
	void zslidderChanged(int value);

	void set_draw_inv_tet_signal(int);
	void save_show_mesh_signal();
	void save_mesh_graph_signal();
	void save_mesh_graph_hex_signal();
	void construct_vertex_texture_signal();
	/*void set_insert_mode_signal(bool);
	void choose_point_signal();
	void start_slider_changed(int value);
	void end_slider_changed(int value);
	void phi_slider_changed(int value);
	void alpha_slider_changed(int value);
	void find_exist_end_signal();
	void draw_active_lines_signal(int);*/
//public slots:
//	void change_insert_mode();

private:
	QTabWidget* tabWidget;

	QCheckBox* draw_main_scene;
	//Show Volume Mesh
	QLabel* leftRight; QCheckBox* leftRightShow;
	QLabel* upDown; QCheckBox* upDownShow;
	QLabel* backFront; QCheckBox* backFrontShow;

	QLabel* xSlider; QSlider* XSlider;
	QLabel* ySlider; QSlider* YSlider;
	QLabel* zSlider; QSlider* ZSlider;
	QLabel* leftLabel;

	QCheckBox* draw_inv_tet;
	QGroupBox* basic_draw_Box;
	QPushButton* save_show_mesh;
	QPushButton* save_mesh_graph;
	QPushButton* save_hex_mesh_graph;
	QPushButton* construct_vertex_texture;
	////insert lines
	//QRadioButton* choose_point_surface;
	//QRadioButton* choose_point_other;
	//QButtonGroup* choose_point_group;
	////QCheckBox* begin_choose_point;
	//QLabel* extend_start; QSlider* start_Slider;
	//QLabel* extend_end;   QSlider* end_Slider;
	//QLabel* angle_phi;    QSlider* phi_Slider;
	//QLabel* angle_alpha;  QSlider* alpha_Slider;
	//QPushButton* find_exist_end;
	//QCheckBox* draw_active_lines;
	//QGroupBox* insert_lines;

	QWidget* showVolumeMesh;
	QScrollArea *viewVM;
	void createSVMWidget();
#pragma endregion Show Volume mesh

private:
	void initDialog();
	void createWidget();
	void createLayout();
};

#endif